<?php

class AuthPage extends \Page
{
	function __construct()
	{
		parent::__construct();
	}

	function render()
	{
		$out      = $this->out;
		$debug    = $this->debug;
		$sid      = $this->getSessionId();
		$USER     = $this->getUser();
		$action   = $this->getRequest( "action" );
		$postdata = file_get_contents("php://input");

		switch ( REDIRECT_URL )
		{
		case "/auth/login/":
			self::login( $postdata );
			break;

		case "/auth/session/":
			self::session( $postdata );
			break;

		case "/auth/logout/":
			$this->logout( $postdata );
			break;

		case "/auth/is_authenticated/":
			echo $this->isAuthenticated() ? "YES" : "NO";
			break;

		default:
			echo "{ 'status' : 'ERROR', 'message', 'INVALID_API_ENDPOINT' }";
			http_response_code( 404 );
		}
	}

	function login( $postdata )
	{
		$sid = $this->getSessionId();

		error_log( $_SERVER["REQUEST_METHOD"] );
		error_log( REDIRECT_URL );
		error_log( $_SERVER["QUERY_STRING"] );
		error_log( $postdata );

		if ( $this->isAuthenticated() )
		{
			$tuple = array(	"USER"        => $this->getUser(),
							"email"       => $this->getEmail(),
							"sessionid"   => $this->getSessionId(),
							"idtype"      => $this->getIDType(),
							"given_name"  => $this->getGivenName(),
							"family_name" => $this->getFamilyName(),
							"user_hash"   => $this->getUserHash(),
							"group_code"  => $this->getGroupCode(),
							"read_only"   => $this->isReadOnly()
			);

			\JSON::EchoStream( (object) $tuple );

			error_log( "Successful login attempt: " . $sid );
		}
		else
		{
			$tuple = array( "error" => "INVALID_CREDENTIALS" );

			\JSON::EchoStream( (object) $tuple );

			error_log( "Unsuccessful login attempt: " . $sid );
		}
	}


	function session()
	{
		if ( $this->isAuthenticated() )
		{
			$tuple = array(
				"USER"        => $this->getUser(),
				"email"       => $this->getEmail(),
				"sessionid"   => $this->getSessionId(),
				"idtype"      => $this->getIDType(),
				"given_name"  => $this->getGivenName(),
				"family_name" => $this->getFamilyName(),
				"user_hash"   => $this->getUserHash(),
				"read_only"   => $this->isReadOnly()
			);

			\JSON::EchoStream( (object) $tuple );
		}
		else
		{
			$tuple = array( "error" => "INVALID_SESSION" );

			\JSON::EchoStream( $tuple );
		}
	}
}
